$('#tutorial').on('click', function () {
    $(document).ready(async function () {
        const driver = new Driver({
            doneBtnText: 'Sair',
            closeBtnText: 'Fechar',
            nextBtnText: 'Próximo',
            prevBtnText: 'Anterior',
            allowClose: false
        });
        driver.defineSteps([{
            element: '#btnFiltros',
            popover: {
                title: 'Botão Filtros',
                description: 'Clique aqui para filtrar a consulta.',
                position: 'right'
            }
        },
        {
            element: '#btnIncluir',
            popover: {
                title: 'Botão Incluir',
                description: 'Clique aqui para iniciar o cadastro de umaregião.',
                position: 'right'
            }
        },
        {
            element: '#tabelaClasseGerencial',
            popover: {
                title: 'Tabela Região',
                description: 'Aqui estão os dados das regiões cadastradas.',
                position: 'top'
            }
        }
        ]);
        driver.start();
    });
});
$(document).ready(async function () {
    const permissaoUsuarioLogado = await permissaoAcessos("CLASSEGERENCIAL");


    $('#txtClasseGerencial').autocompleta(1, `JSON={ "tabela":"CLASSE_GER", "camposSelect":[ "CODIGO chave", "descricao"], "where": null}`);
    $('#btn-ClasseGerencial').pesquisa('#txtClasseGerencial', 'CODIGO', 'DESCRICAO', `/sisplan/funcoes/v1/pesquisa?JSON={ "tabela":"CLASSE_GER", "camposSelect":[ "CODIGO", "DESCRICAO"]}`, 'Pesquisa Classe Gerencial', 'classe_ger');
    $('#btn-limpa-ClasseGerencial').on('click', function () {
        $('#txtClasseGerencial').val('');
    });

    $('#btnFiltros').on('click', function () {
        $('#modal-filtros').modal('show');
    });

    $('#btnIncluir').on('click', function () {
        if (permissaoUsuarioLogado.INCLUI == 'S') {
            window.location.href = "classegerencial/create";
        } else {
            msgAlertaSemConfirmacao("Sem permissão para incluir!");
        }
    });

    function retornaBotaoOpcoes(data, row) {
        var retorno = '<div style="text-align:start;"> ' +
            '    <button class="btn btn-info btn-sm dropdown-toggle btnVerificaOpcoes" type="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false"> ' +
            '      ' + data + ' ' +
            '    </button> ' +
            '    <div class="dropdown-menu"> ' +
            '    <button class="dropdown-item" type="button" title="Editar" id="btn-editar">Editar</button>     ' +
            '    <button class="dropdown-item" type="button" title="Excluir" id="btn-excluir">Excluir</button>  ';
            if (row.LANCA_RATEIO == 'S') {
                retorno += '    <button class="dropdown-item" type="button" title="Rateio" id="btn-rateio">Rateio</button>  ';
            }
            retorno += '</div>';
        return retorno;
    };

    consultaClasse();

    $('#btnConsultar').on('click', async function () {
        $('#modal-filtros').modal('hide');
        await consultaClasse();
    });

    $('#btnLimparFiltros').on('click', async function () {
        $('#txtClasseGerencial').val('');
    });

    async function consultaClasse() {
        try {
            $.LoadingOverlay("show");
            let response;
            let regiao = pegaChave('#txtClasseGerencial') != '' ? ` AND CODIGO = '${pegaChave('#txtClasseGerencial')}'` : '';
            response = await requisicao('GET', '/Sisplan/Funcoes/V1/pesquisa?', `JSON={ "tabela":"CLASSE_GER", "camposSelect":[ "CODIGO", "DESCRICAO", "LANCA_RATEIO"], "where": ["1=1 ${regiao}"]}`, null);

            if (!response) {
                $.LoadingOverlay("hide");
                return;
            }

            let jsonStr = await response.json();
            if (response.status != 200) {
                $.LoadingOverlay("hide");
                msgErro(jsonStr.RESULT[0].mensagem);
                return;
            }

            $('#tabelaClasseGerencial').DataTable({
                destroy: true,
                lengthChange: false,
                "language": {
                    "sEmptyTable": "Nenhum registro encontrado",
                    "sInfo": "_TOTAL_ registros",
                    "sInfoEmpty": " 0 registros",
                    "sInfoFiltered": "(Filtrados de _MAX_ registros)",
                    "sInfoPostFix": "",
                    "sInfoThousands": ".",
                    "sLengthMenu": "_MENU_ resultados",
                    "sLoadingRecords": "Carregando...",
                    "sProcessing": "Processando...",
                    "sZeroRecords": "Nenhum registro encontrado",
                    "sSearch": "Pesquisar",
                    "oPaginate": {
                        "sNext": "Próximo",
                        "sPrevious": "Anterior",
                        "sFirst": "Primeiro",
                        "sLast": "Último"
                    },
                    "oAria": {
                        "sSortAscending": ": Ordenar colunas de forma ascendente",
                        "sSortDescending": ": Ordenar colunas de forma descendente"
                    }
                },

                "autoWidth": true,
                "data": jsonStr.RESULT[0],
                "columns": [{
                    "data": "CODIGO"
                },
                {
                    "data": "DESCRICAO"
                },
                ],
                "columnDefs": [{
                    targets: [0], render: function (data, type, row) {
                        return retornaBotaoOpcoes(data, row);
                    }
                }]
            });

            $.LoadingOverlay("hide");
        } catch (error) {
            console.error(error);
        }

    }

    $('#tabelaClasseGerencial').on('click', '#btn-editar', async function () {
        if (permissaoUsuarioLogado.ALTERA == 'S') {
            let data = $('#tabelaClasseGerencial').DataTable().row($(this).parents('tr')).data();
            window.location.href = `classegerencial/${data.CODIGO}`;
        } else {
            msgAlertaSemConfirmacao("Sem permissão para alterar!");
        }

    });

    $('#tabelaClasseGerencial').on('dblclick', 'tr', async function () {
        if (permissaoUsuarioLogado.ALTERA == 'S') {
            let data = $('#tabelaClasseGerencial').DataTable().row($(this)).data();
            window.location.href = `classegerencial/${data.CODIGO}`;
        } else {
            msgAlertaSemConfirmacao("Sem permissão para alterar!");
        }

    });


    $('#tabelaClasseGerencial').on('click', '#btn-excluir', async function () {
        if (permissaoUsuarioLogado.EXCLUI == 'S') {
            msgAlerta('Você realmente deseja excluir esse registro?', async () => {
                const data = $("#tabelaClasseGerencial").DataTable().row($(this).parents("tr"));
                await excluiRegistro(data);
            });
        } else {
            msgAlertaSemConfirmacao("Sem permissão para excluir!");
        }
    });

    async function excluiRegistro(data) {
        try {
            $.LoadingOverlay("show");
            try {
                let valorLinha = data.data();
                let response = await requisicao("DELETE", "/Sisplan/Cadastros/v1/classegerencial?", `CODIGO=${encodeURIComponent(valorLinha.CODIGO)}`, null);
                if (!response) {
                    return;
                }
                if (response.status != 200) {
                    let jsonStr = await response.json();
                    msgErro(jsonStr.mensagem);
                    return;
                }

                toastr.success("Exclusão efetuada com sucesso!", "Confirmação", {
                    toastClass: "success",
                    iconClasses: {
                        error: "alert-error",
                        info: "alert-info",
                        success: "alert-success",
                        warning: "alert-warning",
                    },
                    positionClass: "toast-top-center",
                    progressBar: true,
                    timeOut: 3000,
                    fadeOut: 1000,
                    onHidden() {
                        data.remove().draw(false);
                    },
                }).css({
                    "margin-top": "20%",
                    width: "500px",
                    "max-width": "500px",
                });

            } catch (error) {
                console.error(error);
            }
        } finally {
            $.LoadingOverlay("hide");
        }
    }

    $('#tabelaClasseGerencial').on('click', '#btn-rateio', async function () {
        if (permissaoUsuarioLogado.ALTERA == 'S') {
            const data = $("#tabelaClasseGerencial").DataTable().row($(this).parents("tr")).data();
            abreModalRateio(data.CODIGO);
        } else {
            msgAlertaSemConfirmacao("Sem permissão para alterar!");
        }
    });

    function abreModalRateio(codigo) {
        try {
            $('#txtCodigoRateio').val(codigo);
            $('#txtTipoRateio').val('C');
            $('#modal-rateio').modal('show');
        } catch (e) {
            console.log(e);
            msgErro(`Não foi possível buscar os dados: ${e}`);
        }
    }

    // $('#tabelaClasseGerencial').on('click', '#btn-excluir', async function () {
    //     if (permissaoUsuarioLogado.EXCLUI == 'S') {
    //         if (confirm('Você realmente deseja excluir esse registro?')) {
    //             try {
    //                 let data = $('#tabelaClasseGerencial').DataTable().row($(this).parents('tr')).data();

    //                 let response = await requisicao('DELETE', '/Sisplan/Cadastros/v1/classegerencial?', `CODIGO=${encodeURIComponent(data.CODIGO)}`, null);

    //                 if (!response) {
    //                     $.LoadingOverlay("hide");
    //                     return;
    //                 };

    //                 let jsonStr = await response.json();
    //                 if (response.status != 200) {
    //                     $.LoadingOverlay("hide");
    //                     msgErro(jsonStr.mensagem);
    //                     return;
    //                 };
    //                 // location.reload();
    //                 $.LoadingOverlay("hide");
    //                 toastr.success(
    //                     'Exclusão efetuada com sucesso!',
    //                     'Confirmação', {
    //                     toastClass: 'alert',
    //                     iconClasses: {
    //                         error: 'alert-error',
    //                         info: 'alert-info',
    //                         success: 'alert-success',
    //                         warning: 'alert-warning'
    //                     },
    //                     positionClass: "toast-top-center",
    //                     progressBar: true,
    //                     timeOut: 3000,
    //                     fadeOut: 1000,

    //                     onHidden() {
    //                         location.reload();
    //                     }
    //                 }
    //                 ).css({
    //                     "margin-top": "20%",
    //                     "width": "500px",
    //                     "max-width": "500px"
    //                 });
    //             } catch (error) {
    //                 console.error(error);
    //             }
    //         }
    //     } else {
    //         msgAlertaSemConfirmacao("Sem permissão para excluir!");
    //     }

    // });
});